
import re

def parse_config_item(s):
    match = re.match("(\w+)\s*=\s*'([^']*)'", s)

    if match:
        return (match.group(1), match.group(2))

    match = re.match("(\w+)\s*=\s*(\d+)",s)

    if match:
        return (match.group(1), int(match.group(2)))

    return None

def parse_config(fh):
    config = {}
    required = {
        'server_host': str,
        'server_port': int,
        'domain': str,
        'password': str,
        'roster_path': str,
        }

    for line in fh:
        if re.match('\s*#', line):
            continue

        if re.match('\s*$', line):
            continue

        item = parse_config_item(line)

        if item:
            name, value = item
            config[name] = value

    for key, cls in required.iteritems():
        if key not in config:
            raise RuntimeError("required configuration value '%s' not found" %
                key)
        elif type(config[key]) != cls:
            raise RuntimeError(
                "expecting a %s for configuration value '%s', but got a %s" %
                (cls, key, type(config[key])))

    return config

def read_config(path):
    return parse_config(file(path))

